{********************************************************}
{* FreePascal DOS port by Udo Giacomozzi <ugcm@usa.net> *}
{* Version 1.00                                         *}
{* Problems compiling programs using MIDAS/FPC? Read    *}
{* the file install.htm !                               *}
{********************************************************}

{* Note you CAN'T use MIDAS unless you've read the license! *}


{*      midasdll.pas
 *
 * MIDAS DLL programming interface Delphi interface unit
 *
 * $Id: midasdll.pas,v 1.5 1997/07/31 14:30:58 pekangas Exp $
 *
 * Copyright 1996,1997 Housemarque Inc
 *
 * This file is part of MIDAS Digital Audio System, and may only be
 * used, modified and distributed under the terms of the MIDAS
 * Digital Audio System license, "license.txt". By continuing to use,
 * modify or distribute this file you indicate that you have
 * read the license and understand and accept it fully.
*}

unit midasdll;

{$PACKRECORDS 4}
{$MODE Delphi}


interface


uses
  dpmiexcp;  // this is needed so linker doesn't complain about _exit def.

//type Integer=LongInt;

type
  BOOL  = LongBool;

const
    { enum MIDASoptions }
    MIDAS_OPTION_NONE = 0;
    MIDAS_OPTION_MIXRATE = 1;
    MIDAS_OPTION_OUTPUTMODE = 2;
    MIDAS_OPTION_MIXBUFLEN = 3;
    MIDAS_OPTION_MIXBUFBLOCKS = 4;
    MIDAS_OPTION_DSOUND_MODE = 5;
    MIDAS_OPTION_DSOUND_HWND = 6;
    MIDAS_OPTION_DSOUND_OBJECT = 7;
    MIDAS_OPTION_DSOUND_BUFLEN = 8;
    MIDAS_OPTION_16BIT_ULAW_AUTOCONVERT = 9;
    MIDAS_OPTION_FILTER_MODE = 10;
    MIDAS_OPTION_MIXING_MODE = 11;
    MIDAS_OPTION_DEFAULT_STEREO_SEPARATION = 12;
    MIDAS_OPTION_FORCE_NO_SOUND = 13;



    { enum MIDASmodes }
    MIDAS_MODE_NONE = 0;
    MIDAS_MODE_MONO = 1;
    MIDAS_MODE_STEREO = 2;
    MIDAS_MODE_8BIT = 4;
    MIDAS_MODE_16BIT = 8;
    MIDAS_MODE_8BIT_MONO = MIDAS_MODE_8BIT or MIDAS_MODE_MONO;
    MIDAS_MODE_8BIT_STEREO = MIDAS_MODE_8BIT or MIDAS_MODE_STEREO;
    MIDAS_MODE_16BIT_MONO = MIDAS_MODE_16BIT or MIDAS_MODE_MONO;
    MIDAS_MODE_16BIT_STEREO = MIDAS_MODE_16BIT or MIDAS_MODE_STEREO;

    { enum MIDASsampleTypes }
    MIDAS_SAMPLE_NONE = 0;
    MIDAS_SAMPLE_8BIT_MONO = 1;
    MIDAS_SAMPLE_16BIT_MONO = 2;
    MIDAS_SAMPLE_8BIT_STEREO = 3;
    MIDAS_SAMPLE_16BIT_STEREO = 4;
    MIDAS_SAMPLE_ADPCM_MONO = 5;
    MIDAS_SAMPLE_ADPCM_STEREO = 6;
    MIDAS_SAMPLE_ULAW_MONO = 7;
    MIDAS_SAMPLE_ULAW_STEREO = 8;

    { enum MIDASloop }
    MIDAS_LOOP_NO = 0;
    MIDAS_LOOP_YES = 1;

    { enum MIDASpanning }
    MIDAS_PAN_LEFT = -64;
    MIDAS_PAN_MIDDLE = 0;
    MIDAS_PAN_RIGHT = 64;
    MIDAS_PAN_SURROUND = $80;

    { enum MIDASchannels }
    MIDAS_CHANNEL_AUTO = $FFFF;
    MIDAS_ILLEGAL_CHANNEL = $FFFF;

    { enum MIDASdsoundModes }
    MIDAS_DSOUND_DISABLED = 0;
    MIDAS_DSOUND_STREAM = 1;
    MIDAS_DSOUND_PRIMARY = 2;
    MIDAS_DSOUND_FORCE_STREAM = 3;

    { enum MIDASpositions }
    MIDAS_POSITION_DEFAULT = $FFFFFFFF;

    { enum MIDASfilterModes }
    MIDAS_FILTER_NONE = 0;
    MIDAS_FILTER_LESS = 1;
    MIDAS_FILTER_MORE = 2;
    MIDAS_FILTER_AUTO = 3;

    { enum MIDASechoFilterTypes }
    MIDAS_ECHO_FILTER_NONE = 0;
    MIDAS_ECHO_FILTER_LOWPASS = 1;
    MIDAS_ECHO_FILTER_HIGHPASS = 2;

    { enum MIDASmixingModes }
    MIDAS_MIX_NORMAL_QUALITY = 0;
    MIDAS_MIX_HIGH_QUALITY = 1;

    { enum MIDASsamplePlayStatus }
    MIDAS_SAMPLE_STOPPED = 0;
    MIDAS_SAMPLE_PLAYING = 1;



type MIDASmoduleInfo =
    record
        songName : array[0..31] of char;
        songLength : integer;
        numPatterns : integer;
        numInstruments : integer;
        numChannels : integer;
    end;
    PMIDASmoduleInfo = ^MIDASmoduleInfo;

type MIDASinstrumentInfo =
    record
        instName : array[0..31] of char;
    end;
    PMIDASinstrumentInfo = ^MIDASinstrumentInfo;

type MIDASplayStatus =
    record
        position : dword;
        pattern : dword;
        row : dword;
        syncInfo : integer;
        songLoopCount : dword
    end;
    PMIDASplayStatus = ^MIDASplayStatus;

type MIDASecho =
    record
        delay : dword;
        gain : integer;
        reverseChannels : integer;
        filterType : dword;
    end;
    PMIDASecho = ^MIDASecho;

type MIDASechoSet =
    record
        feedback : integer;
        gain : integer;
        numEchoes : integer;
        echoes : PMIDASecho;
    end;
    PMIDASechoSet = ^MIDASechoSet;


    MIDASmodule = pointer;
    MIDASmodulePlayHandle = DWORD;
    MIDASsample = DWORD;
    MIDASsamplePlayHandle = DWORD;
    MIDASstreamHandle = pointer;
    Pbyte = ^byte;
    MIDASechoHandle = pointer;



function MIDASgetLastError : integer; cdecl;
function MIDASgetErrorMessage(errorCode : integer) : PChar; cdecl;

function MIDASstartup : BOOL; cdecl;
function MIDASconfig : BOOL; cdecl;
function MIDASloadConfig(fileName : PChar) : BOOL; cdecl;
function MIDASsaveConfig(fileName : PChar) : BOOL; cdecl;
function MIDASreadConfigRegistry(key : dword; subKey : PChar) : BOOL; cdecl;
function MIDASwriteConfigRegistry(key : dword; subKey : PChar) : BOOL; cdecl;

function MIDASinit : BOOL; cdecl;
function MIDASsetOption(option : integer; value : dword) : BOOL; cdecl;
function MIDASgetOption(option : integer) : dword; cdecl;
function MIDASclose : BOOL; cdecl;
function MIDASsuspend : BOOL; cdecl;
function MIDASresume : BOOL; cdecl;
function MIDASopenChannels(numChannels : integer) : BOOL; cdecl;
function MIDAScloseChannels : BOOL; cdecl;
function MIDASsetAmplification(amplification : dword) : BOOL; cdecl;
function MIDASstartBackgroundPlay(pollRate : dword) : BOOL; cdecl;
function MIDASstopBackgroundPlay : BOOL; cdecl;
function MIDASpoll : BOOL; cdecl;
function MIDASlock : BOOL; cdecl;
function MIDASunlock : BOOL; cdecl;
function MIDASgetVersionString : PChar; cdecl;

function MIDASallocateChannel : dword; cdecl;
function MIDASfreeChannel(channel : dword) : BOOL; cdecl;

function MIDASloadModule(fileName : PChar) : MIDASmodule; cdecl;
function MIDASplayModule(module : MIDASmodule; loopSong : BOOL) :
    MIDASmodulePlayHandle; cdecl;
function MIDASplayModuleSection(module : MIDASmodule; startPos, endPos,
    restartPos : dword; loopSong : BOOL) : MIDASmodulePlayHandle; cdecl;
function MIDASstopModule(playHandle : MIDASmodulePlayHandle) : BOOL;
    cdecl;
function MIDASfreeModule(module : MIDASmodule) : BOOL; cdecl;

function MIDASgetPlayStatus(playHandle : MIDASmodulePlayHandle;
    status : PMIDASplayStatus) : BOOL; cdecl;
function MIDASsetPosition(playHandle : MIDASmodulePlayHandle;
    newPosition : integer) : BOOL; cdecl;
function MIDASsetMusicVolume(playHandle : MIDASmodulePlayHandle;
    volume : dword) : BOOL; cdecl;
function MIDASgetModuleInfo(module : MIDASmodule; info : PMIDASmoduleInfo) :
    BOOL; cdecl;
function MIDASgetInstrumentInfo(module : MIDASmodule; instNum : integer;
    info : PMIDASinstrumentInfo) : BOOL; cdecl;
function MIDASfadeMusicChannel(playHandle : MIDASmodulePlayHandle; channel,
    fade : dword) : BOOL; cdecl;

function MIDASloadRawSample(fileName : PChar; sampleType,
    loopSample : integer) : MIDASsample; cdecl;
function MIDASloadWaveSample(fileName : PChar; loopSample : integer) :
    MIDASsample; cdecl;
function MIDASfreeSample(sample : MIDASsample) : BOOL; cdecl;
function MIDASallocAutoEffectChannels(numChannels : dword) : BOOL; cdecl;
function MIDASfreeAutoEffectChannels : BOOL; cdecl;
function MIDASplaySample(sample : MIDASsample; channel : dword;
    priority : integer; rate, volume : dword; panning : integer) :
    MIDASsamplePlayHandle;
    cdecl;
function MIDASstopSample(sample : MIDASsamplePlayHandle) : BOOL; cdecl;
function MIDASsetSampleRate(sample : MIDASsamplePlayHandle; rate : dword) :
    BOOL; cdecl;
function MIDASsetSampleVolume(sample : MIDASsamplePlayHandle; volume : dword)
    : BOOL; cdecl;
function MIDASsetSamplePanning(sample : MIDASsamplePlayHandle;
    panning : integer) : BOOL; cdecl;
function MIDASsetSamplePriority(sample : MIDASsamplePlayHandle;
    priority : integer) : BOOL; cdecl;
function MIDASgetSamplePlayStatus(sample : MIDASsamplePlayHandle) : dword;
    cdecl;

function MIDASplayStreamFile(fileName : PChar;
    sampleType : dword; sampleRate : dword; bufferLength : dword;
    loopStream : integer) : MIDASstreamHandle; cdecl;
function MIDASplayStreamWaveFile(fileName : PChar; bufferLength : dword;
    loopStream : integer) : MIDASstreamHandle; cdecl;
function MIDASstopStream(stream : MIDASstreamHandle) : BOOL; cdecl;

function MIDASplayStreamPolling(sampleType : dword;
    sampleRate : dword; bufferLength : dword) : MIDASstreamHandle; cdecl;
function MIDASfeedStreamData(stream : MIDASstreamHandle; data : Pbyte;
    numBytes : dword; feedAll : BOOL) : dword; cdecl;

function MIDASsetStreamRate(stream : MIDASstreamHandle; rate : dword)
    : BOOL; cdecl;
function MIDASsetStreamVolume(stream : MIDASstreamHandle; volume : dword)
    : BOOL; cdecl;
function MIDASsetStreamPanning(stream : MIDASstreamHandle; panning : integer)
     : BOOL; cdecl;

function MIDASgetStreamBytesBuffered(stream : MIDASstreamHandle) : BOOL;
    cdecl;
function MIDASpauseStream(stream : MIDASstreamHandle) : BOOL; cdecl;
function MIDASresumeStream(stream : MIDASstreamHandle ) : BOOL; cdecl;

function MIDASaddEchoEffect(echoSet : PMIDASechoSet) : MIDASechoHandle;
    cdecl;
function MIDASremoveEchoEffect(echoHandle : MIDASechoHandle) : BOOL;
    cdecl;


implementation

(* Libraries that need to be linked *)
{$linklib m}     // standard C libs
{$linklib c}
{$linklib midas} // MIDAS library
{$linklib alleg} // Allegro game library (needed by MIDAS)

function MIDASgetLastError : integer;
     cdecl; external;
function MIDASgetErrorMessage(errorCode : integer) : PChar;
     cdecl; external;

function MIDASstartup : BOOL;
     cdecl; external;
function MIDASconfig : BOOL;
     cdecl; external;
function MIDASloadConfig(fileName : PChar) : BOOL;
     cdecl; external;
function MIDASsaveConfig(fileName : PChar) : BOOL;
     cdecl; external;
function MIDASreadConfigRegistry(key : dword; subKey : PChar) : BOOL;
     cdecl; external;
function MIDASwriteConfigRegistry(key : dword; subKey : PChar) : BOOL;
     cdecl; external;


function MIDASinit : BOOL;
     cdecl; external;
function MIDASsetOption(option : integer; value : dword) : BOOL;
     cdecl; external;
function MIDASgetOption(option : integer) : dword;
     cdecl; external;
function MIDASclose : BOOL;
     cdecl; external;
function MIDASsuspend : BOOL;
     cdecl; external;
function MIDASresume : BOOL;
     cdecl; external;
function MIDASopenChannels(numChannels : integer) : BOOL;
     cdecl; external;
function MIDAScloseChannels : BOOL;
     cdecl; external;
function MIDASsetAmplification(amplification : dword) : BOOL;
     cdecl; external;
function MIDASstartBackgroundPlay(pollRate : dword) : BOOL;
     cdecl; external;
function MIDASstopBackgroundPlay : BOOL;
     cdecl; external;
function MIDASpoll : BOOL;
     cdecl; external;
function MIDASlock : BOOL;
     cdecl; external;
function MIDASunlock : BOOL;
     cdecl; external;
function MIDASgetVersionString : PChar;
     cdecl; external;

function MIDASallocateChannel : dword;
     cdecl; external;
function MIDASfreeChannel(channel : dword) : BOOL;
     cdecl; external;

function MIDASloadModule(fileName : PChar) : MIDASmodule;
     cdecl; external;
function MIDASplayModule(module : MIDASmodule; loopSong : BOOL) :
    MIDASmodulePlayHandle;
     cdecl; external;
function MIDASplayModuleSection(module : MIDASmodule; startPos, endPos,
    restartPos : dword; loopSong : BOOL) : MIDASmodulePlayHandle;
     cdecl; external;
function MIDASstopModule(playHandle : MIDASmodulePlayHandle) : BOOL ;
     cdecl; external;
function MIDASfreeModule(module : MIDASmodule) : BOOL;
     cdecl; external;

function MIDASgetPlayStatus(playHandle : MIDASmodulePlayHandle;
    status : PMIDASplayStatus) : BOOL;
     cdecl; external;
function MIDASsetPosition(playHandle : MIDASmodulePlayHandle;
    newPosition : integer) : BOOL;
     cdecl; external;
function MIDASsetMusicVolume(playHandle : MIDASmodulePlayHandle;
    volume : dword) : BOOL;
     cdecl; external;
function MIDASgetModuleInfo(module : MIDASmodule; info : PMIDASmoduleInfo) :
    BOOL;
     cdecl; external;
function MIDASgetInstrumentInfo(module : MIDASmodule; instNum : integer;
    info : PMIDASinstrumentInfo) : BOOL;
     cdecl; external;
function MIDASfadeMusicChannel(playHandle : MIDASmodulePlayHandle; channel,
    fade : dword) : BOOL;
     cdecl; external;

function MIDASloadRawSample(fileName : PChar; sampleType,
    loopSample : integer) : MIDASsample;
     cdecl; external;
function MIDASloadWaveSample(fileName : PChar; loopSample : integer) :
    MIDASsample;
     cdecl; external;
function MIDASfreeSample(sample : MIDASsample) : BOOL;
     cdecl; external;
function MIDASallocAutoEffectChannels(numChannels : dword) : BOOL;
     cdecl; external;
function MIDASfreeAutoEffectChannels : BOOL;
     cdecl; external;
function MIDASplaySample(sample : midasSample; channel : dword;
    priority : integer; rate, volume : dword; panning : integer) :
    MIDASsamplePlayHandle;
     cdecl; external;
function MIDASstopSample(sample : MIDASsamplePlayHandle) : BOOL;
     cdecl; external;
function MIDASsetSampleRate(sample : MIDASsamplePlayHandle; rate : dword) :
    BOOL;
     cdecl; external;
function MIDASsetSampleVolume(sample : MIDASsamplePlayHandle; volume : dword)
    : BOOL;
     cdecl; external;
function MIDASsetSamplePanning(sample : MIDASsamplePlayHandle;
    panning : integer) : BOOL;
     cdecl; external;
function MIDASsetSamplePriority(sample : MIDASsamplePlayHandle;
    priority : integer) : BOOL;
     cdecl; external;
function MIDASgetSamplePlayStatus(sample : MIDASsamplePlayHandle) : dword;
     cdecl; external;

function MIDASplayStreamFile(fileName : PChar;
    sampleType : dword; sampleRate : dword; bufferLength : dword;
    loopStream : integer) : MIDASstreamHandle;
     cdecl; external;
function MIDASplayStreamWaveFile(fileName : PChar; bufferLength : dword;
    loopStream : integer) : MIDASstreamHandle;
     cdecl; external;
function MIDASstopStream(stream : MIDASstreamHandle) : BOOL;
     cdecl; external;

function MIDASplayStreamPolling(sampleType : dword;
    sampleRate : dword; bufferLength : dword) : MIDASstreamHandle;
     cdecl; external;
function MIDASfeedStreamData(stream : MIDASstreamHandle; data : Pbyte;
    numBytes : dword; feedAll : BOOL) : dword;
     cdecl; external;

function MIDASsetStreamRate(stream : MIDASstreamHandle; rate : dword)
    : BOOL;
     cdecl; external;
function MIDASsetStreamVolume(stream : MIDASstreamHandle; volume : dword)
    : BOOL;
     cdecl; external;
function MIDASsetStreamPanning(stream : MIDASstreamHandle; panning : integer)
     : BOOL;
      cdecl; external;

function MIDASgetStreamBytesBuffered(stream : MIDASstreamHandle) : BOOL;
     cdecl; external;
function MIDASpauseStream(stream : MIDASstreamHandle) : BOOL;
     cdecl; external;
function MIDASresumeStream(stream : MIDASstreamHandle ) : BOOL;
     cdecl; external;

function MIDASaddEchoEffect(echoSet : PMIDASechoSet) : MIDASechoHandle;
     cdecl; external;
function MIDASremoveEchoEffect(echoHandle : MIDASechoHandle) : BOOL;
     cdecl; external;



BEGIN
END.

{*
 * $Log: midasdll.pas,v $
 * Revision 1.5  1997/07/31 14:30:58  pekangas
 * Added option MIDAS_OPTION_FORCE_NO_SOUND
 *
 * Revision 1.4  1997/07/31 10:56:48  pekangas
 * Renamed from MIDAS Sound System to MIDAS Digital Audio System
 *
 * Revision 1.3  1997/07/29 16:57:12  pekangas
 * Added sample playing status query
 *
 * Revision 1.2  1997/07/29 16:51:09  pekangas
 * Updated for 1.1 beta 1
 *
 * Revision 1.1  1997/05/23 14:47:44  pekangas
 * Initial revision
 *
*}